MODULE SumVek;

PROCEDURE NeumaierSum(VAR X : ARRAY OF LONGREAL;
                          N : CARDINAL) : LONGREAL;

          VAR sum,c,t : LONGREAL;
              i       : CARDINAL;
BEGIN
    sum := X[0];
    c   := 0.0;
    FOR i:=1 TO N-1 DO
      t := sum + X[i];
      IF (ABS(sum) >= ABS(X[i])) THEN
        c:=c + (sum - t) + X[i];
      ELSE
        c:=c + (X[i] - t) + sum;
      END;
      sum := t;
    END;
    RETURN sum + c;
END NeumaierSum;

PROCEDURE NeumaierProdSum(VAR X,Y : ARRAY OF LONGREAL;
                              N   : CARDINAL) : LONGREAL;

          VAR sum,c,t,xy : LONGREAL;
              i          : CARDINAL;
BEGIN
    sum := X[0]*Y[0];
    c   := 0.0;
    FOR i:=1 TO N-1 DO
      xy := X[i]*Y[i];
      t := sum + xy;
      IF (ABS(sum) >= ABS(xy)) THEN
        c:=c + (sum - t) + xy;
      ELSE
        c:=c + (xy - t) + sum;
      END;
      sum := t;
    END;
    RETURN sum + c;
END NeumaierProdSum;

END SumVek.
